﻿using Syncfusion.XForms.Cards;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;
using Xamarin.Forms.Internals;
using Xamarin.Essentials;

namespace WorkingWithCard
{
	// Learn more about making custom code visible in the Xamarin.Forms previewer
	// by visiting https://aka.ms/xamarinforms-previewer
	[DesignTimeVisible(false)]
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();
		}
	}

    public class ViewModel: INotifyPropertyChanged
    {
        public ObservableCollection<Model> Data { get; set; }

        private ICommand cardTappedCommand;

        public event PropertyChangedEventHandler PropertyChanged;

        public ICommand CardTappedCommand { get; set; }

        private object cardDescription;

        public object CardDescription
        {
            get { return cardDescription; }
            set 
            {
                cardDescription = value;
                RaisePropertyChanged("CardDescription");
            }
        }

        void RaisePropertyChanged(string name)         {             if (PropertyChanged != null)             {                 PropertyChanged(this, new PropertyChangedEventArgs(name));             }         }

        public ViewModel()
        {
            CardTappedCommand = new Command<object>(CardTappedEvent);

            Data = new ObservableCollection<Model>();

            Data.Add(new Model
            {
                Name = "Leather Black Sofa",
                Price = 999,
                Rating = "4.9",
                Offer = "5% Offer",
                ImagePath = "Card_sofa2.png",
                Description = "Warranty covers up to 5 years. This frame’s special feature is its bookcase headboard."
            });

            Data.Add(new Model
            {
                Name = "Wooden Standing Drawer",
                Price = 199,
                Rating = "3.9",
                Offer = "50% Offer",
                ImagePath = "Card_hall.png",
                Description = "This versatile wardrobe strikes the perfect balance between style and functionality. Equipped with a mirror and multiple shelves."
            });

            Data.Add(new Model
            {
                Name = "Semi Fabric Sofa",
                Price = 299,
                Rating = "2.9",
                Offer = "25% Offer",
                ImagePath = "Card_sofa.png",
                Description = "This sofa’s frame is made of engineered wood, which is stable and climate-resistant. Protected with a scratch-resistant finish."
            });

            Data.Add(new Model
            {
                Name = "Dinning Chair",
                Price = 3933333333333333335,
                Rating = "4.9",
                Offer = "15% Offer",
                ImagePath = "Card_chair.png",
                Description = "Made of plywood to reduce weight and costs, these end tables still look like solid cherry."
            });

            Data.Add(new Model
            {
                Name = "Fabric White Sofa",
                Price = 99,
                Rating = "3.9",
                Offer = "35% Offer",
                ImagePath = "Card_hall2.png",
                Description = "Lightweight but sturdy, this nightstand is made of particleboard with a maple veneer or painted white."
            });
        }

        private void CardTappedEvent(object args)
        {
            SfCardView cardView = (args as TappedEventArgs).Parameter as SfCardView;
            SfCardLayout cardLayout = cardView.Parent as SfCardLayout;
        }
    }

    public class Model : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private string description;

        public string Description
        {
            get { return description; }
            set
            {
                description = value;
                OnPropertyChanged();
            }
        }

        private string imagePath;

        public string ImagePath
        {
            get { return imagePath; }
            set
            {
                imagePath = value;
                OnPropertyChanged();
            }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                OnPropertyChanged();
            }
        }

        private long price;

        public long Price
        {
            get { return price; }
            set
            {
                price = value;
                OnPropertyChanged();
            }
        }

        private string offer;

        public string Offer
        {
            get { return offer; }
            set
            {
                offer = value;
                OnPropertyChanged();
            }
        }

        private string rating;

        public string Rating
        {
            get { return rating; }
            set
            {
                rating = value;
                OnPropertyChanged();
            }
        }

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
